-- name: King Boo's Revenge 2
-- description: Difficult 182 star hack.\nMade by Sizzlingmario4 and Thebloody7.\nPorted by Sunk. Custom exclamation box behavior port by Agent X.
-- incompatible: romhack
-------------------------
-----Warp exit nodes-----
-------------------------

gLevelValues.exitCastleLevel = LEVEL_CASTLE_GROUNDS
gLevelValues.exitCastleArea = 1
gLevelValues.exitCastleWarpNode = 0x0A
gLevelValues.skipCreditsAt = LEVEL_CASTLE_GROUNDS

---------------------------
------Everything else------
---------------------------

gServerSettings.skipIntro = true

local shellMario = false

--Detects if Mario is currently doing the shell mario glitch
function shell_interact(m, obj, intType)
    if m.playerIndex ~= 0 then return end
    ---@type NetworkPlayer
    local np = gNetworkPlayers[0]

    if (intType == INTERACT_KOOPA_SHELL) and
    (np.currLevelNum == LEVEL_BITS) and
    ((m.action & ACT_GROUP_MASK) == ACT_GROUP_SUBMERGED) then
        shellMario = true
    end
end

--Makes Mario move much faster if he is doing the shell mario glitch.
function shell_mario(m)
    if m.playerIndex ~= 0 then return end

    local obj = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvKoopaShell)

    if (dist_between_objects(m.marioObj, obj) > 50) or (obj == nil) then
        shellMario = false
    end

    if shellMario == true then
        m.vel.x = m.vel.x * 4
        m.vel.z = m.vel.z * 4
    end
end

hook_event(HOOK_ON_INTERACT, shell_interact)
hook_event(HOOK_BEFORE_PHYS_STEP, shell_mario)